package ru.landgrafhomyak.db.serdha0.api.misc

import ru.landgrafhomyak.db.serdha0.api.runtime.InputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow

public interface Mapper<mUE : Any> {
	public val uExt: mUE

	public interface InputColumn<RT, DT : DatabaseType<RT>, mUE : Any> : Column<RT, DT, mUE>
	public interface OutputColumn<RT, DT : DatabaseType<RT>, mUE : Any> : QueryParam<RT, DT, mUE>

	public fun interface InputLinker<mUE : Any, qUE : Any> {
		public fun link(linker: Scope<mUE, qUE>)

		public interface Scope<_mUE : Any, qUE : Any> {
			public val mUE: _mUE
			public operator fun <RT, DT : DatabaseType<RT>> set(p: InputColumn<RT, DT, _mUE>, e: IntermediateColumn<RT, DT, qUE>)
		}
	}

	public fun interface OutputLinker<mUE : Any, qUE : Any, oUE : Any> {
		public fun link(linker: Scope<mUE, qUE>): oUE

		public interface Scope<_mUE : Any, qUE : Any> {
			public val mUE: _mUE
			public operator fun <RT, DT : DatabaseType<RT>> get(p: OutputColumn<RT, DT, _mUE>): IntermediateColumn<RT, DT, qUE>
		}
	}

	public interface Constructor<mUE : Any> {
		public fun createMapper(context: Scope<mUE>): Action<mUE>

		public interface Scope<mUE : Any> {
			public val types: DatabaseType.Provider
			public fun <RT, DT : DatabaseType<RT>> input(name: String, type: DT): InputColumn<RT, DT, mUE>
			public fun <RT, DT : DatabaseType<RT>> output(name: String, type: DT): OutputColumn<RT, DT, mUE>
		}
	}

	public interface Action<mUE : Any> {
		public fun calculate(input: OutputRow<mUE>, output: InputRow<mUE>)
	}
}