package ru.landgrafhomyak.db.serdha0.api.runtime

import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.table.RowId
import ru.landgrafhomyak.db.serdha0.api.table.Table
import ru.landgrafhomyak.db.serdha0.api.queries._Query

public interface Executor {
	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun _startTransaction(): Transaction

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Query.Void2Table<QueryUserExtension>): OutputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Query.Params2Table<QueryUserExtension>): InputRow._Scope<QueryUserExtension, OutputRow._Iterator<QueryUserExtension, Unit>>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Query.Table2Void<QueryUserExtension>): InputRow._Iterator<QueryUserExtension, Unit>

	@Suppress("FunctionName")
	@LowLevelApi
	public suspend fun <QueryUserExtension : Any> _executeAutoTransactedQuery(compiledQuery: _Query.Params2Void<QueryUserExtension>): InputRow._Scope<QueryUserExtension, Unit>

	public interface AtomicScript<C, A, R> {
		public suspend fun executeTransaction(transaction: Transaction, context: C, args: A): R
	}

	public suspend fun <C, A, R> transaction(script: AtomicScript<C, A, R>, context: C, args: A): R

	public fun <TableUserException : Any, V> mapOfRowIds(
		table: Table<TableUserException, *>,
		builder: (MutableMap<OutputRow<TableUserException>, V>) -> Unit
	): Map<RowId<TableUserException>, V>

	public fun <TableUserException : Any, V> mutableMapOfRowIds(table: Table<TableUserException, *>): MutableMap<RowId<TableUserException>, V>
}