package ru.landgrafhomyak.db.serdha0.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.Column

/**
 * Descriptor of index. Used for schema manipulations.
 *
 * @param OwnerTableUserExtension Type of [owner table's][CheckConstraint.table] user expression for static reporting errors when this descriptor passed to wrong table.
 */
public interface Index<OwnerTableUserExtension : Any> {
	/**
	 * Name of index for debugging, errors and raw schema access.
	 */
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("name")
	public val name: String

	/**
	 * Table that contains this index. For debugging.
	 */
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("table")
	public val table: Table<OwnerTableUserExtension, *>

	/**
	 * Columns that are indexed by this index. For debugging.
	 */
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("columns")
	public val columns: List<Column<*, *, OwnerTableUserExtension>>
}